# This file was automatically generated by oml2-scaffold V2.10.1
# The syntax of this file is documented at [0].
#
# [0] http://doc.mytestbed.net/doc/omf/OmfEc/Backward/AppDefinition.html

defApplication('oml:app:httperf', 'httperf') do |app|

  app.version(2, 11, 0)
  app.shortDescription = 'HTTP performance measurement tool'
  app.description = %{
httperf is a tool to measure web server performance. It speaks the HTTP
protocol both in its HTTP/1.0 and HTTP/1.1 flavors and offers a variety of
workload generators. While running, it keeps track of a number of performance
metrics that are summarized in the form of statistics that are printed at the
end of a test run.
  }
  app.path = "/usr/bin/httperf-oml2"

  app.defProperty('add-header', 'Specifies to include string S as an additional request header.',
		  '--add-header', :type => :string)
  app.defProperty('burst-length', 'Specifies the length of bursts.',
		  '--burst-length', :type => :integer)
  app.defProperty('no-host-hdr', 'Specifies that the "Host:" header should not be included.',
		  '--no-host-hdr', :type => :boolean)
  app.defProperty('client', 'I/N specifies that the machine httperf is running on is client I out of a total of N clients.',
		  '--client', :type => :string)
  app.defProperty('close-with-reset','Requests that httperf closes TCP connections by sending a RESET instead of going through the normal TCP connection shutdown handshake.',
		  '--close-with-reset', :type => :boolean)
  app.defProperty('debug', 'Set debug level to N.',
		  '--debug', :type => :integer, :mnemonic => 'd')
  app.defProperty('failure-status', 'Specifies that an HTTP response status code of N should be treated as a failure.',
		  '--failure-status', :type => :integer)
  app.defProperty('help', 'Prints a summary of available options and their parameters.',
		  '--help', :type => :boolean, :mnemonic => 'h')
  app.defProperty('hog', 'This option requests to use up as many TCP ports as necessary.',
		  '--hog', :type => :boolean)
  app.defProperty('http-version', 'Specifies the version string that should be included in the requests sent to the server.',
		  '--http-version', :type => :string, :default => '1.1')
  app.defProperty('max-connections', 'Specifies that at most N connections are opened for each session.',
		  '--max-connections', :type => :integer)
  app.defProperty('max-piped-calls', 'Specifies that at most N pipelined calls are issued on each connection.',
		  '--max-piped-calls', :type => :integer)
  app.defProperty('method', 'Specifies the method that should be used when issuing an HTTP request.',
		  '--method', :type => :string, :default => 'GET')
  app.defProperty('num-calls', 'This option specifies the total number of calls to issue on each connection before closing it.',
		  '--num-calls', :type => :integer, :default => 1)
  app.defProperty('num-conns', 'This option specifies the total number of connections to create.',
		  '--num-conns', :type => :integer, :default => 1)
  app.defProperty('period', '[D]T1[,T2] Specifies the time interval between the creation of connections or sessions.',
		  '--period', :type => :integer, :default => '0')
  app.defProperty('port', 'This option specifies the port number N on which the web server is listening for HTTP requests.',
		  '--port', :type => :integer, :default => '80')
  app.defProperty('print-reply', '[header|body] Requests the printing of the reply headers, body, and summary.',
		  '--print-reply', :type => :string)
  app.defProperty('print-request', '[header|body] Requests the printing of the request headers, body (if one is present), and summary.',
		  '--print-request', :type => :string)
  app.defProperty('rate', 'Specifies the fixed rate at which connections or sessions are created.',
		  '--rate', :type => :double, :default => 0, :unit => "connection/second")
  app.defProperty('recv-buffer', 'Specifies the maximum size of the socket receive buffer.',
		  '--recv-buffer', :type => :integer,
		  :default => 16384, :unit => "byte") # param.recv_buffer_size is set to 16384 in httperf.c -> 16 KiB
  app.defProperty('retry-on-failure', 'If specified, a call that results in a failure response is retried immediately instead of causing the session to fail.',
		  '--retry-on-failure', :type => :boolean)
  app.defProperty('send-buffer', 'Specifies the maximum size of the socket send buffers used to send HTTP requests.',
		  '--send-buffer', :type => :integer,
		  :default => 4096, :unit => "byte") # param.send_buffer_size is set to 4096 in httperf.c -> 4 KiB
  app.defProperty('server', 'Specifies the IP hostname of the server.', '--server',
		  :type => :string, :default => 'localhost')
  app.defProperty('server-name', 'Specifies the (default) server name that appears in the "Host:" header.', '--server-name',
		  :type => :string)
  app.defProperty('session-cookie', 'When this option is turned on, cookie managment is enabled on a per-session basis.',
		  '--session-cookie', :type => :boolean)
  app.defProperty('ssl', 'Specifies that all communication between httperf and the server should utilize the Secure Sockets Layer (SSL) protocol.',
		  '--ssl', :type => :boolean)
  app.defProperty('ssl-ciphers', 'This option specifies the list L of cipher suites that httperf may use in negotiating a secure connection with the server.',
		  '--ssl-ciphers', :type => :string)
  app.defProperty('ssl-no-reuse', 'Reuse SSL session IDs in order to avoid the expense of repeating the (slow) SSL handshake.',
		  '--ssl-no-reuse', :type => :boolean)
  app.defProperty('think-timeout', 'Specifies the maximum time that the server may need to initiate sending the reply for a given request.',
		  '--think-timeout', :type => :double, :default => 0, :unit => "second")
  app.defProperty('timeout', 'Specifies the amount of time X that httperf is willing to wait for a server reaction.',
		  '--timeout', :type => :double, :default => 0, :unit => "second")
  app.defProperty('uri', 'Specifies that URI S should be accessed on the server.',
		  '--uri', :type => :string)
  app.defProperty('use-timer-cache', ' This feature allows the user to specify whether they want to cache timestamps or not',
		  '--use-timer-cache', :type => :boolean)
  app.defProperty('verbose', '',
		  '--verbose', :type => :boolean, :mnemonic => 'v')
  app.defProperty('version', 'Prints the version of httperf.',
		  '--version', :type => :boolean, :mnemonic => 'V')
  app.defProperty('wlog', '[B,F] This option can be used to generate a specific sequence of URI accesses.',
		  '--wlog', :type => :string)
  app.defProperty('wsess', '[N1,N2,X] Requests the generation and measurement of sessions instead of individual requests.',
		  '--wsess', :type => :string)
  app.defProperty('wsesslog', '[N,X,F] This specifies a session workload generator similar to --wsess.',
		  'wsesslog', :type => :string)
  app.defProperty('wset', '[N,X] This option can be used to walk through a list of URIs at a given rate.',
		  '--wset', :type => :string)


  # Declare measurement points; generate OML injection helpers with
  #  oml2-scaffold --oml httperf.rb
  app.defMeasurement("total") do |mp|
    mp.defMetric('connections', :uint32, :unit => "connection",
		 :description => "Total number of connections")
    mp.defMetric('requests', :uint32, :unit => "request",
		 :description => "Total number of requests")
    mp.defMetric('replies', :uint32, :unit => "reply",
		 :description => "Total number of replies")
    mp.defMetric('test_duration', :double, :unit => 'second',
		 :description => "Duration of the full run")
  end

  app.defMeasurement("connection_rate") do |mp|
    mp.defMetric('rate', :double, :unit => 'connection/second',
		 :description => "Connection rate")
    mp.defMetric('duration', :double, :unit => 'millisecond/connection',
		 :description => "Connection duration")
    mp.defMetric('max_concurrent', :uint32, :unit => "connection",
		 :description => "Maximum number of concurrent connections")
  end

  app.defMeasurement("connection_time") do |mp|
    mp.defMetric('min', :double, :unit => 'millisecond',
		 :description => "Minimum connection duration")
    mp.defMetric('avg', :double, :unit => 'millisecond',
		 :description => "Average connection duration")
    mp.defMetric('max', :double, :unit => 'millisecond',
		 :description => "Maximum connection duration")
    mp.defMetric('median', :double, :unit => 'millisecond',
		 :description => "Median connection duration")
    mp.defMetric('stddev', :double, :unit => 'millisecond',
		 :description => "Standard deviation of the connection duration")
    mp.defMetric('connect', :double, :unit => 'millisecond',
		 :description => "Average connection time")
  end

  app.defMeasurement("connection_length") do |mp|
    mp.defMetric('length', :double, :unit => 'reply/connection',
		 :description => "Ratio of replies per connections")
  end

  app.defMeasurement("request_rate") do |mp|
    mp.defMetric('rate', :double, :unit => 'request/second',
		 :description => "Request rate")
    mp.defMetric('duration', :double, :unit => 'millisecond/request',
		 :description => "Request duration")
  end

  app.defMeasurement("request_size") do |mp|
    mp.defMetric('size', :double, :unit => 'byte',
		 :description => "Request size")
  end

  app.defMeasurement("reply_rate") do |mp|
    mp.defMetric('min', :double, :unit => 'reply/second',
		 :description => "Minimum reply rate")
    mp.defMetric('avg', :double, :unit => 'reply/second',
		 :description => "Average reply rate")
    mp.defMetric('max', :double, :unit => 'reply/second',
		 :description => "Maximum reply rate")
    mp.defMetric('stddev', :double, :unit => 'reply/second',
		 :description => "tandard deviation of the reply rate")
    mp.defMetric('samples', :uint32, :unit => "sample",
		 :description => "Number of reply samples")
  end

  app.defMeasurement("reply_time") do |mp|
    mp.defMetric('response', :double, :unit => 'millisecond',
		 :description => "Response time")
    mp.defMetric('transfer', :double, :unit => 'millisecond',
		 :description => "Transfer time")
  end

  app.defMeasurement("reply_size") do |mp|
    mp.defMetric('header', :double, :unit => 'byte',
		 :description => "Header size")
    mp.defMetric('content', :double, :unit => 'byte',
		 :description => "Content size")
    mp.defMetric('footer', :double, :unit => 'byte',
		 :description => "Footer size")
    mp.defMetric('total', :double, :unit => 'byte',
		 :description => "Total reply size")
  end

  app.defMeasurement("reply_status") do |mp|
    mp.defMetric('status_1xx', :uint32,
		 :description => "Number of 1xx statuses")
    mp.defMetric('status_2xx', :uint32,
		 :description => "Number of 2xx statuses")
    mp.defMetric('status_3xx', :uint32,
		 :description => "Number of 3xx statuses")
    mp.defMetric('status_4xx', :uint32,
		 :description => "Number of 4xx statuses")
    mp.defMetric('status_5xx', :uint32,
		 :description => "Number of 5xx statuses")
  end

  app.defMeasurement("cpu_time") do |mp|
    mp.defMetric('user_time', :double, :unit => 'second',
		 :description => "Time spent running user code")
    mp.defMetric('system_time', :double, :unit => 'second',
		 :description => "Time spent running system code")
    mp.defMetric('user_ratio', :double, :unit => '%',
		 :description => "Ratio of time spent running user code")
    mp.defMetric('system_ratio', :double, :unit => '%',
		 :description => "Ratio of time spent running system code")
    mp.defMetric('total_ratio', :double, :unit => '%',
		 :description => "Ratio of total time run")
  end

  app.defMeasurement("net_io") do |mp|
    mp.defMetric('throughput', :double, :unit => 'byte/second',
		 :description => "Throughput")
  end

  app.defMeasurement("errors") do |mp|
    mp.defMetric('total', :uint32, :unit => "error",
		 :description => "Number of errors")
    mp.defMetric('client_timo', :uint32, :unit => "timeout",
		 :description => "Number of client timeouts")
    mp.defMetric('socket_timo', :uint32, :unit => "timeout",
		 :description => "Number fo socket timeouts (ETIMEDOUT)")
    mp.defMetric('connrefused', :uint32, :unit => "connection",
		 :description => "Number of connection refused (ECONNREFUSED)")
    mp.defMetric('connreset', :uint32, :unit => "connection",
		 :description => "Number of connection reset (ECONNRESET)")
    mp.defMetric('fd_unavail', :uint32, :unit => "error",
		 :description => "Number of errors due to unavailable file descriptors")
    mp.defMetric('addrunavail', :uint32, :unit => "error",
		 :description => "Number of errors due incorrect interface or address (EADDRNOTAVAIL)")
    mp.defMetric('ftab_full', :uint32, :unit => "error",
		 :description => "Number of errors due to full file tables")
    mp.defMetric('other', :uint32, :unit => "error",
		 :description => "Number of other errors")
  end

  app.defMeasurement("connections") do |mp|
    mp.defMetric('id', :guid,
		 :description => "Globally unique identifier for the connection")
    mp.defMetric('header', :double, :unit => 'byte',
		 :description => "Total size of headers received")
    mp.defMetric('content', :double, :unit => 'byte',
		 :description => "Total size of content received")
    mp.defMetric('footer', :double, :unit => 'byte',
		 :description => "Totale size of footer received")
    mp.defMetric('lifetime', :double, :unit => 'millisecond',
		 :description => "Duration of the connection")
  end

  app.defMeasurement("calls") do |mp|
    mp.defMetric('id', :guid,
		 :description => "Globally unique identifier for the request")
    mp.defMetric('connection_id', :guid,
		 :description => "Globally unique identifier for the connection in which the request has been sent")
  end

  app.defMeasurement("call_times") do |mp|
    mp.defMetric('call_id', :guid,
		 :description => "Globally unique identifier for the request")
    mp.defMetric('response', :double, :unit => 'millisecond',
		 :description => "Response time")
  end

  app.defMeasurement("call_sizes") do |mp|
    mp.defMetric('call_id', :guid,
		 :description => "Globally unique identifier for the request")
    mp.defMetric('header', :double, :unit => 'byte',
		 :description => "Header size")
    mp.defMetric('content', :double, :unit => 'byte',
		 :description => "Content size")
    mp.defMetric('footer', :double, :unit => 'byte',
		 :description => "Footer size")
  end

end

# Local Variables:
# mode:ruby
# End:
# vim: ft=ruby:sw=2
